//
//  AppDelegate.m
//  VideoPlayer
//
//  Created by Jon Manning on 11/04/12.
//  Copyright (c) 2012 Secret Lab. All rights reserved.
//

#import "AppDelegate.h"
#import <AVFoundation/AVFoundation.h>
#import <QuartzCore/QuartzCore.h>

@interface AppDelegate () {
    AVPlayer* player;
}

@end

@implementation AppDelegate

@synthesize window = _window;
@synthesize playerView = _playerView;


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    NSURL* contentURL = [[NSBundle mainBundle] URLForResource:@"TestVideo" withExtension:@"m4v"];
    player = [AVPlayer playerWithURL:contentURL];
    
    AVPlayerLayer* playerLayer = [AVPlayerLayer playerLayerWithPlayer:player];
    [self.playerView.layer addSublayer:playerLayer];
    playerLayer.frame = self.playerView.layer.bounds;
    playerLayer.autoresizingMask = kCALayerWidthSizable | kCALayerHeightSizable;
    
    
    CIFilter* blurFilter = [CIFilter filterWithName:@"CIGaussianBlur"];
    [blurFilter setDefaults];
    
    CIFilter* hexFilter = [CIFilter filterWithName:@"CIHexagonalPixellate"];
    [hexFilter setDefaults];
    
    //playerLayer.filters = [NSArray arrayWithObjects:blurFilter, hexFilter, nil];

        
    player.actionAtItemEnd = AVPlayerActionAtItemEndNone;
    
}

- (IBAction)play:(id)sender {
    [player play];
}

- (IBAction)playSlowMotion:(id)sender {
    [player setRate:0.25];
}

- (IBAction)rewind:(id)sender {
    [player seekToTime:kCMTimeZero];
}
@end
